View Issue Details

IDProjectCategoryView StatusLast Update
0002580Far ManagerMacropublic2015-01-14 13:40
ReporterJohnDoeAssigned Toshmuel 
PrioritynormalSeverityminorReproducibilitysometimes
Status closedResolutionfixed 
Product Version3.0 
Target VersionFixed in Version3.0 
Summary0002580: AKey может не работать при вызове макроса через eval(key,2)
DescriptionОписываемая проблема проявляется в случае, если вызов eval произошёл из не из макроса, а например
- обработчика события
- из макрофайла но за предалами определения макросов
- из командной строки, меню пользователя,...

В этих случаях функция akey возвращает пустую строку или мусор (символ с кодом 1).
Спецклавиша Keys "AKey" также не выполняет свою функцию.
Steps To ReproduceНаиболее актуальна данная проблема при вызове из обработчика события, но для простоты привожу шаги для воспроизведения из командной строки:

Macro {
  area="Common"; key="l";
  action=function()
    Keys "AKey"
  end;
}

lm:post eval("l",2)
Additional InformationЧастное проявление проблемы описано ранее в 0002309.
Вариант решения предложен тут 0002309:0011738
TagsNo tags attached.
BuildLMb472

Activities

JohnDoe

2015-01-05 12:03

updater   bugnote:0013385

Last edited: 2015-01-05 12:47

View 2 revisions

Похоже что после LuaMacro build 465 проблема более не воспроизводится

Edit: Проблема-таки есть, если вызываемый по eval макрос назначен на более чем одну клавишу, или регэксп.

Подробности тут: 0002309:0013386

JohnDoe

2015-01-07 14:05

updater   bugnote:0013389

build 467 - порядок

JohnDoe

2015-01-13 10:20

updater   bugnote:0013399

-- build 470
Macro {
  area="Common"; key="abc";
  action=function()
    Keys "AKey"
  end;
}

Запускаю lua: eval("abc",2)

В результате в командную строку вставляется символ с кодом 0xffff

JohnDoe

2015-01-14 10:39

updater   bugnote:0013403

build 472: проблемы больше нет

Issue History

Date Modified Username Field Change
2014-01-27 16:36 JohnDoe New Issue
2015-01-05 12:03 JohnDoe Note Added: 0013385
2015-01-05 12:47 JohnDoe Note Edited: 0013385 View Revisions
2015-01-07 14:05 JohnDoe Note Added: 0013389
2015-01-13 10:20 JohnDoe Note Added: 0013399
2015-01-14 10:39 JohnDoe Note Added: 0013403
2015-01-14 13:40 shmuel Build => LMb472
2015-01-14 13:40 shmuel Status new => closed
2015-01-14 13:40 shmuel Assigned To => shmuel
2015-01-14 13:40 shmuel Resolution open => fixed
2015-01-14 13:40 shmuel Fixed in Version => 3.0